#include <algorithm>
#include <cstdio>
#include <iostream>
using namespace std;
#pragma warning (disable : 4996)

struct req
{
	size_t l, r;
	int q;
};
bool comp(req a, req b)
{
	return a.q > b.q;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	size_t n, m;
	cin >> n >> m;
	req *data = new req[m];
	for (size_t i = 0; i < m; i++)
		cin >> data[i].l >> data[i].r >> data[i].q;
	sort(data, data + m, comp);
	int *arr = new int[n];
	fill(arr, arr + n, 1);
	for (size_t i = 0; i < m; i++)
		fill(arr + data[i].l - 1, arr + data[i].r, data[i].q);
	for (size_t i = 0; i < m; i++)
		if (*max_element(arr + data[i].l - 1, arr + data[i].r) != data[i].q)
		{
			cout << "FAIL";
			return 0;
		}
	cout << "EASY" << endl;
	for (size_t i = 0; i < n; i++)
		cout << arr[i] << ' ';
}