#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))
#define ft first
#define sd second

const int INF = 1e9 + 7;
typedef pair<int, int> pii;
typedef long long ll;

struct rrr
{
    int u, v;
    int ln;
    rrr() : u(0), v(0), ln(0) {};
    rrr(int _i, int _j, int _ln) : u(_i), v(_j), ln(_ln) {};
};

vector<rrr> g;

int dsu[10100];
int dsu_size[10100];

void init(int n)
{
    for (int i = 0; i < n; ++i)
        dsu[i] = i,
        dsu_size[i] = 1;
}

int get(int i)
{
    return dsu[i] == i ? i : dsu[i] = get(dsu[i]);
}

int link(int a, int b)
{
    a = get(a);
    b = get(b);
    if (a != b)
    {
        if (dsu_size[a] > dsu_size[b]) swap(a, b);
        dsu[a] = b;
        dsu_size[b] += dsu_size[a];
    }
    return dsu_size[b];
}

int check(int n, int l)
{
    init(n);
    int ans = 1;
    for (rrr& it : g)
        if (it.ln >= l)
            ans = max(ans, link(it.u, it.v));
    return ans-1;
}

void solve()
{
    int n, m, k;
    scanf("%d%d%d", &n, &m, &k);
    g.resize(m);
    for (rrr& it : g)
        scanf("%d%d%d", &it.u, &it.v, &it.ln),
        it.u--, it.v--;

    int mask = 1<<30;
    int ans = 0;
    while (mask)
    {
        if (check(n, ans | mask) >= k)
            ans |= mask;
        mask >>= 1;
    }
    printf("%d", ans);
}

// #define LOCAL

int main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
