#include <iostream>
#include <string>
#include <vector>

using namespace std;

vector <long long> g;

long long gcd(long long a, long long b)
{
    while (a && b)
    {
        if (a > b) a %= b;
        else b %= a;
    }
    return a + b;
}

long long solve()
{
    long long NOK = g[g.size() - 1] * g[g.size() - 2] / gcd(g[g.size() - 1], g[g.size() - 2]);
    for (int i = g.size() - 3; i >= 0; i--)
        NOK *= g[i] / gcd(NOK, g[i]);
    return NOK;
}

int main()
{
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> g[i];
    cout << solve();
    return 0;
}
