#include <algorithm>
#include <cstdio>
#include <iostream>
#include <vector>
using namespace std;
#pragma warning (disable : 4996)

void intersect(int l1, int r1, int l2, int r2, int res[2])
{
	int l = max(l1, l2), r = min(r1, r2);
	if (l < r)
	{
		res[0] = l;
		res[1] = r;
	}
	else
		res[0] = res[1] = 0;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int x1[3], y1[3], x2[3], y2[3];
	for (size_t i = 0; i < 3; i++)
	{
		cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
		if (x1[i] > x2[i])
			swap(x1[i], x2[i]);
		if (y1[i] > y2[i])
			swap(y1[i], y2[i]);
	}
	int s12 = 0, s13 = 0, s23 = 0, s123 = 0;
	int curIntX[2], curIntY[2];

	intersect(x1[0], x2[0], x1[1], x2[1], curIntX);
	intersect(y1[0], y2[0], y1[1], y2[1], curIntY);
	if (*curIntX != 0 && *curIntY != 0)
		s12 = (curIntX[1] - curIntX[0]) * (curIntY[1] - curIntY[0]);

	intersect(x1[0], x2[0], x1[2], x2[2], curIntX);
	intersect(y1[0], y2[0], y1[2], y2[2], curIntY);
	if (*curIntX != 0 && *curIntY != 0)
		s13 = (curIntX[1] - curIntX[0]) * (curIntY[1] - curIntY[0]);

	intersect(x1[1], x2[1], x1[2], x2[2], curIntX);
	intersect(y1[1], y2[1], y1[2], y2[2], curIntY);
	if (*curIntX != 0 && *curIntY != 0)
		s23 = (curIntX[1] - curIntX[0]) * (curIntY[1] - curIntY[0]);

	int intX2[2], intY2[2], intX3[2], intY3[2];
	intersect(x1[0], x2[0], x1[1], x2[1], intX2);
	intersect(y1[0], y2[0], y1[1], y2[1], intY2);
	intersect(curIntX[0], curIntX[1], intX2[0], intX2[1], intX3);
	intersect(curIntY[0], curIntY[1], intY2[0], intY2[1], intY3);
	if (*intX3 != 0 && *intY3 != 0)
		s123 = (intX3[1] - intX3[0]) * (intY3[1] - intY3[0]);

	cout << (x2[0] - x1[0]) * (y2[0] - y1[0]) + (x2[1] - x1[1]) * (y2[1] - y1[1]) + (x2[2] - x1[2]) * (y2[2] - y1[2]) - s12 - s13 - s23 + s123;
}